/* Permutations by Jay Fredrick Ransom, Ph. D.

*/
namespace perms

public enum
	m = 1,	--number of items
	n,	--taken at a time
	p,	--permutation number
	np, --total number of permutations
	switched, 
	number,
	switch_with

object response

public function init (seq perm)
	perm [switched] = {}
	perm [number] = {}
	perm [switch_with] = {}
	
	for i = 1 to perm [m] do
		perm [switched] = append (perm [switched], 0)
		perm [number] = append (perm [number], i)
		perm [switch_with] = append (perm [switch_with], i)
	end for	
	return perm
end function

public function permutation (int noOfItems, int takenAtATime)

	int mm, nn
	seq perm = {n, m, p, np, switched, number, switch_with}
	if noOfItems = 0 then
		return {}
	end if
	if takenAtATime > noOfItems then
		takenAtATime = noOfItems
	end if
	
	perm [m] = noOfItems
	mm = noOfItems
	perm [n] = takenAtATime
	nn = takenAtATime
	perm [p] = 1
	perm [np] = 1
	
	for i = mm to mm - nn +1 by -1 do
	
		perm [np] *= i
	end for

	perm = init (perm)

	return perm
end function

function new_perm(seq perm,   int nn)

	seq aPerm
	object  temp, b
	
	if perm [m] = 0 then
		return {}
	end if
	
	if nn > perm [m] then
		perm [p] = 1
		return perm
	else 
		if perm [switched] [nn] then
			b = perm [switch_with] [nn] - 1
			temp = perm [number] [b]
			perm [number] [b] = perm [number] [nn]
			perm [number] [nn] = temp
			perm [switch_with] [nn] = b
			perm [switched] [nn] = 0
			return new_perm (perm, nn)
		end if
		b = perm [switch_with] [nn]
		if b > 1 then
			b -= 1
			temp = perm [number] [b]
			perm [number] [b] = perm [number] [nn]
			perm [number] [nn] = temp
			perm [switched] [nn] = 1
			perm [p] += 1
			return perm
		else 
			if b < 1 then
				return {}
			else
				perm [switch_with] [nn] = nn
				return new_perm (perm, nn + 1)
			end if
		end if
	end if

end function

public function make_new_perm(seq perm)
	int mm, nn
	mm = perm [m]
	nn = perm [n]
	return new_perm (perm, mm-nn+1)
	
end function
